import ScalarFieldBuilder from './fields/ScalarFieldBuilder'
import IdFieldBuilder from './fields/IdFieldBuilder'
import LinkFieldBuilder from './fields/LinkFieldBuilder'
import {TKeyFieldType, Multitenancy, BaseSavableEntity, PermissionType, MethodType, DateUnit} from './buildedTypes'
import CatalogBuilder from './CatalogBuilder'
import BaseBuilder from './BaseBuilder'
import FormsBuilder from './ui/FormsBuilder'
import { FieldBuilder } from './types'
import ViewLinkFieldBuilder from './fields/ViewLinkFieldBuilder'
import { camelPlural, pascal } from '../../utils/cases'
import * as R from 'ramda'
import PermissionBuilder from './PermissionBuilder'
import PageBuilder from './PageBuilder'
import BaseModelBuilder from './mehods/BaseModelBuilder'
import MethodBuilder, { MethodsModelsHolder } from './mehods/MethodBuilder'

// const readPermissions: string[] = [
//   'all',
//   'get',
//   'count',
//   'meta',
// ]

// const permissions: string[] = [
//   ...readPermissions,
//   'create',
//   'update',
//   'delete',
// ]

abstract class BaseSavableEntityBuilder extends BaseBuilder implements MethodsModelsHolder {
  id: IdFieldBuilder
  permissions: PermissionBuilder[] = []
  fields: FieldBuilder[] = []
  uniqueConstraints: string[][] = []
  protected type = 'catalog'
  titleField: ScalarFieldBuilder | IdFieldBuilder
  deletable = false
  editable = true
  singleKey = true
  logging = false
  auditable = true
  creatableByUser = true
  updatableByUser = true
  removableByUser = true
  exportableByUser = true
  space = ''
  sortField = 'id'
  sortOrder: 'ASC' | 'DESC' = 'DESC'
  sybsystems: string[] = []
  forms?: FormsBuilder
  predefinedElements: Record<string, any>[] = []
  devPerefinedElements: Record<string, any>[] = []
  searchEnabled = true
  externalSearch = false
  elasticOnly = false
  multitenancy: Multitenancy = 'none'
  commonElementsVisibleToAll = false
  title: Record<string, {singular: string, plural: string}> = {}
  externalSearchName: string | undefined = undefined
  sharded = false
  isExternalSearch = false
  clearDBAfter: {count: number, unit: DateUnit}[] = [];
  allowedToChange: string = ''
  pages: PageBuilder[] = [];
  protected methods: MethodBuilder[] = []
  protected models: BaseModelBuilder[] = []
  labels: string[] = [];

  constructor(name: string, defaultLanguage: string, title?: {singular?: string, plural?: string}) {
    super(name, defaultLanguage, title)
    this.setTitle({plural: title?.plural ?? name, singular: title?.singular ?? title?.plural ?? name})

    this.id = new IdFieldBuilder('id', defaultLanguage)
      .setTitle('Id', 'en')
      .setTitle('Ид', 'ru')
    this.titleField = new IdFieldBuilder('id', defaultLanguage)

    this.setTitleFieldByName(this.getKey().name)

    this.addPage(`${name}.all`, `/${name}`, `${camelPlural(this.type)}.${this.name}.title.plural`).addRequiredPermission(`${name}.all`);
    this.addPage(`${name}.create`, `/${name}/create`, `${camelPlural(this.type)}.${this.name}.title.singular`).addRequiredPermission(`${name}.create`);

    this.addMethod('all', MethodType.Query).setExportedToApi();
    this.addMethod('create', MethodType.Mutation).setExportedToApi();
    this.addMethod('update', MethodType.Mutation).setExportedToApi();
    this.addMethod('delete', MethodType.Mutation).setExportedToApi();

    this.addLabel(`${camelPlural(this.type)}.${this.name}.title.plural`);
    this.addLabel(`${camelPlural(this.type)}.${this.name}.title.singular`);
  }

  setTitle(title: {plural: string, singular: string}, language?: string) {
    const resultedLangiage = language ? language : this.defaultLanguage
    this.title[resultedLangiage] = title

    return this
  }

  setExternalSearch() {
    this.externalSearch = true
    this.getKey().setType('string').setAutoGenerated(true)
    this.externalSearchName = `external${pascal(this.name)}SearchTrackings`
    this.setSearchEnabled()

    return this
  }

  setElasticOnly() {
    this.elasticOnly = true;
    this.getKey().setType('string').setAutoGenerated(true);

    return this;
  }

  setSearchEnabled(searchEnabled?: boolean) {
    this.searchEnabled = searchEnabled ?? true

    const filed = this.getFieldIfExist('search');
    if (!searchEnabled && filed) {
      this.delField('search')
    }

    return this
  }

  setAuditable(auditable?: boolean) {
    this.auditable = auditable ?? true

    return this
  }

  setDeletable(deletable?: boolean) {
    this.deletable = deletable ?? true

    return this
  }
  setEditable(editable?: boolean) {
    this.editable = editable ?? true

    return this
  }
  setCreatableByUser(creatableByUser?: boolean) {
    this.creatableByUser = creatableByUser ?? true

    return this
  }
  setUpdatableByUser(updatableByUser?: boolean) {
    this.updatableByUser = updatableByUser ?? true

    return this
  }
  setRemovableByUser(removableByUser?: boolean) {
    this.removableByUser = removableByUser ?? true

    return this
  }
  setExportableByUser(exportableByUser?: boolean) {
    this.exportableByUser = exportableByUser ?? true

    return this
  }
  getKey() {
    if (!this.singleKey) {
      throw new Error('There is no single key')
    }

    return this.id
  }

  getShardedFields () {
    return this.fields.filter((f) => f.sharded)
  }

  getUniqueConstraints (registrarDependent = false): string[][] {
    const uniqueConstraints = [...this.uniqueConstraints];

    const uniqKeys = this.getShardedFields().map(f => f.name)

    const isRegistrarDependentSumRegistry = this.type === 'sumRegistry' && registrarDependent;

    if (!isRegistrarDependentSumRegistry && !R.isEmpty(uniqKeys) && !R.equals(uniqKeys, ['id'])) {
      uniqueConstraints.push(uniqKeys);
    }

    return uniqueConstraints;
  }

  getFileds(): FieldBuilder[] {
    return [this.id, ...this.fields]
  }

  getFieldIfExist(name: string): FieldBuilder | undefined {
    return this.getFileds().find((f) => f.name === name);
  }

  getFiled(name: string): FieldBuilder {
    const filed = this.getFieldIfExist(name)
    if (!filed) {
      throw new Error(`There is no field with name "${name}"`)
    }

    return filed
  }

  getLinkFileds(): LinkFieldBuilder[] {
    return this.getFileds().filter(
      (field) => field.category === 'link'
    ) as LinkFieldBuilder[]
  }

  addField(
    name: string,
    title?: string,
    { isTitleField }: { isTitleField?: boolean } = {}
  ): ScalarFieldBuilder {
    if (this.fields.some((f) => f.name === name)) {
      throw new Error(
        `There is already field with name "${name}". Entity ${this.name}`
      )
    }

    const field = new ScalarFieldBuilder(name, this.defaultLanguage, title)
    this.fields.push(field)

    if (isTitleField) {
      this.setTitleFieldByName(name)
    }
    
    this.addLabel(`${camelPlural(this.type)}.${this.name}.fields.${name}`);

    return field
  }

  delField(name: string) {
    this.fields = this.fields.filter((f) => f.name !== name)
    
    this.delLabel(`${camelPlural(this.type)}.${this.name}.fields.${name}`);

    return this
  }

  addLinkField(
    e: string | CatalogBuilder,
    name: string,
    title?: string
  ): LinkFieldBuilder {
    let entity = e
    if (this.fields.some((f) => f.name === name)) {
      throw new Error(
        `There is already field with name "${name}". Entity ${this.name}`
      )
    }

    // get name from entity
    if (entity instanceof CatalogBuilder) {
      entity = entity.name
    }

    const field = new LinkFieldBuilder(
      entity,
      name,
      this.defaultLanguage,
      title
    )

    // get field type from entity
    if (e instanceof CatalogBuilder) {
      const entityType = e.fields.find(
        (field: FieldBuilder) => field instanceof IdFieldBuilder
      )?.type as TKeyFieldType | undefined

      if (entityType && field.type !== entityType) {
        field.setType(entityType)
      }
    }

    this.fields.push(field)

    return field
  }

  addFileField(name: string, title?: string): LinkFieldBuilder {
    const entity = 'files'
    if (this.fields.some((f) => f.name === name)) {
      throw new Error(
        `There is already field with name "${name}". Entity ${this.name}`
      )
    }

    const field = new LinkFieldBuilder(
      entity,
      name,
      this.defaultLanguage,
      title
    )
    field.setPredefinedLinkedEntity('file')

    this.fields.push(field)

    return field
  }

  addImageField(name: string, title?: string): LinkFieldBuilder {
    const entity = 'files'
    if (this.fields.some((f) => f.name === name)) {
      throw new Error(
        `There is already field with name "${name}". Entity ${this.name}`
      )
    }

    const field = new LinkFieldBuilder(
      entity,
      name,
      this.defaultLanguage,
      title
    )
    field.setPredefinedLinkedEntity('file')
    field.setFileType('image')

    this.fields.push(field)

    return field
  }

  addViewLinkField(
    e: string | CatalogBuilder,
    name: string,
    title?: string
  ): ViewLinkFieldBuilder {
    let entity = e
    if (this.fields.some((f) => f.name === name)) {
      throw new Error(
        `There is already field with name "${name}". Entity ${this.name}`
      )
    }

    // get name from entity
    if (entity instanceof CatalogBuilder) {
      entity = entity.name
    }

    const field = new ViewLinkFieldBuilder(
      entity,
      name,
      this.defaultLanguage,
      title
    )

    // get field type from entity
    if (e instanceof CatalogBuilder) {
      const entityType = e.fields.find(
        (field: FieldBuilder) => field instanceof IdFieldBuilder
      )?.type as TKeyFieldType | undefined

      if (entityType && field.type !== entityType) {
        field.setType(entityType)
      }
    }

    this.fields.push(field)

    return field
  }

  setTitleFieldByName(titleField: string) {
    const field = this.getFileds().find((f) => f.name === titleField) as
      | ScalarFieldBuilder
      | IdFieldBuilder
      | undefined
    if (!field) {
      throw new Error(
        `There is no field with name "${titleField}", you can not set it as a title field. Entity ${this.name}`
      )
    }

    this.titleField = field

    return this
  }

  setSort(field: string, order: 'ASC' | 'DESC') {
    if (!this.getFileds().some((f) => f.name === field)) {
      throw new Error(
        `There is no field with name "${field}", you can not set sort to this field. Entity ${this.name}`
      )
    }

    this.sortField = field
    this.sortOrder = order

    return this
  }

  addUniqueConstraint(fields: string[]): BaseSavableEntityBuilder {
    const currentFields = this.getFileds()

    // const currentRequiredFields = currentFields.filter(f => f.required);
    const currentFieldNames = currentFields.map((f) => f.name)

    // const currentRequiredFieldNames = currentRequiredFields.map(f => f.name);
    if (fields.some((f) => !currentFieldNames.includes(f))) {
      throw new Error(`You trying to add constraint for non existing field.
      Current fields: ${currentFields.map(f => f.title[this.defaultLanguage]).join(', ')}, fields for constraint: ${fields.join(', ')}, field not in current: ${fields.filter(
        (f) => !currentFieldNames.includes(f)
      )}.
      Entity ${this.name}`)
    }

    // if (fields.some(f => !currentRequiredFieldNames.includes(f))) {
    //   throw new Error(`You trying to add constraint for not required field. Presence of not required filed breaks uniquiness check.
    //   Current required fields: ${currentFields}, fields for constrain: ${fields}, field not in current: ${fields.filter(f => !currentRequiredFieldNames.includes(f))}.
    //   Entity ${this.name}`);
    // }

    this.uniqueConstraints.push(fields)

    return this
  }

  addPemission(name: string, type: PermissionType): BaseSavableEntityBuilder {
    if (this.permissions.some((p) => p.name === name)) {
      throw new Error(`Entity "${this.name}" already have "${name}" pemission`)
    }

    const permission = new PermissionBuilder(`${this.name}.${name}`, type, this.defaultLanguage, `${this.name}.${name}`)
    this.permissions.push(permission)

    return this
  }

  addPage(
    name: string,
    link: string,
    label: string,
    title?: string,
  ) {
    if (this.pages.some(p => p.name === name)) {
      throw new Error(`There is already "${name}" page`);
    }

    const page = new PageBuilder(name, link, label, this.defaultLanguage, title)

    this.pages.push(page)

    return page
  }

  getPageByName(pageName: string) {
    const found =  this.pages.find(p => p.name === pageName);

    if (!found) {
      throw new Error(`Page "${pageName}" not found`);
    }

    return found;
  }

  getAllPage() {
    return this.getPageByName(`${this.name}.all`);
  }

  getCreatePage() {
    return this.getPageByName(`${this.name}.create`);
  }

  addMethod(
    name: string,
    methodType: MethodType,
    title?: string,
  ): MethodBuilder {
    if (this.methods.some((f) => f.name === name)) {
      throw new Error(`There is already field with name "${name}" in args model`)
    }

    const field = new MethodBuilder(this, name, methodType, this.defaultLanguage, title)
    this.methods.push(field)

    return field
  }

  addModel(
    name: string,
    title?: string,
  ): BaseModelBuilder {
    if (this.models.some((f) => f.name === name)) {
      throw new Error(`There is already field with name "${name}" in args model`)
    }

    const model = new BaseModelBuilder(this, name, title ?? name, this.defaultLanguage)
    this.models.push(model)

    return model
  }

  getMethods() {
    return this.methods;
  }

  getModels() {
    return this.models;
  }
  
  addLabel(label: string) {
    if (this.labels.some(l => l === label)) {
      throw new Error(`There is already label "${label}" in "${this.name}" entity`);
    }

    this.labels.push(label);
  }

  delLabel(label: string) {
    this.labels = this.labels.filter((l) => l !== label)

    return this
  }

  build (): BaseSavableEntity {
    return {
      ...super.build(),
      title: this.title,
      singleKey: this.singleKey,
      // titleField: this.titleField.build(),
      titleField: this.titleField.name,
      // linkFields: this.getLinkFileds().map(f => f.build()),
      // keyField: this.getKey().build(),
      keyField: this.getKey().name,
      fields: this.getFileds().map((field) => field.build()),
      uniqueConstraints: this.getUniqueConstraints(),
      forms: this.getForms().build(),
      predefinedElements: this.predefinedElements,
      devPerefinedElements: this.devPerefinedElements,
      auditable: this.auditable,
      externalSearch: this.externalSearch,
      elasticOnly: this.elasticOnly,
      searchEnabled: this.searchEnabled,
      sortField: this.sortField,
      sortOrder: this.sortOrder,
      multitenancy: this.multitenancy,
      commonElementsVisibleToAll: this.commonElementsVisibleToAll,
      externalSearchName: this.externalSearchName,
      sharded: this.sharded,
      isExternalSearch: this.isExternalSearch,
      creatableByUser: this.creatableByUser,
      updatableByUser: this.updatableByUser,
      removableByUser: this.removableByUser,
      exportableByUser: this.exportableByUser,
      clearDBAfter: this.clearDBAfter,
      allowedToChange: this.allowedToChange,
      permissions: this.permissions.map(p => p.build()),
      pages: this.pages.map(p => p.build()),
      models: this.models.map(m => m.build()),
      methods: this.methods.map(m => m.build()),
      labels: this.labels,
    }
  }

  initFormas(): BaseSavableEntityBuilder {
    if (!this.forms) {
      this.forms = new FormsBuilder(() => this)
    }

    return this
  }

  getForms(): FormsBuilder {
    this.initFormas()

    return this.forms as FormsBuilder
  }

  addPredefinedElements(fields: Record<string, any>[]) {
    this.predefinedElements.push(...fields)
  }

  setPredefinedElements(fields: Record<string, any>[]) {
    this.predefinedElements = fields
  }

  addDevPredefinedElements(fields: Record<string, any>[]) {
    this.devPerefinedElements.push(...fields)
  }

  setDevPredefinedElements(fields: Record<string, any>[]) {
    this.devPerefinedElements = fields
  }

  setMultitenancy(
    multitenancy: Multitenancy,
    commonElementsVisibleToAll?: boolean
  ) {
    this.multitenancy = multitenancy

    if (
      multitenancy !== 'optional' &&
      commonElementsVisibleToAll !== undefined
    ) {
      throw new Error(
        `You are trying to specify commonElementsVisibleToAll, but multitenancy is not optional (${multitenancy})`
      )
    }

    this.commonElementsVisibleToAll =
      commonElementsVisibleToAll || multitenancy === 'optional'

    this.delField('tenantId')
    if (multitenancy !== 'none') {
      const tenantField = this.addLinkField('tenants', 'tenantId')
        .setType('int')
        .setNotUpdatableByUser()
      if (multitenancy === 'required') {
        tenantField
          .setRequired()
          .setNotUpdatableByUser(
            undefined,
            "await ctx.service('profile').getRequiredTenantId()"
          )
      }
    }
  }

  setSharded (value = true) {
    this.sharded = value

    return this
  }
  setIsExternalTable () {
    this.isExternalSearch = true
    return this
  }
  setClearDBAfter (count: number, unit: DateUnit) {
    this.clearDBAfter.push({'count': count, 'unit': unit});

    return this
  }
  setAllowedToChange (value: string = '') {
    this.allowedToChange = value

    return this
  }
}

export default BaseSavableEntityBuilder
